/* A Bison parser, made from /home/rich/gnome_dev/cvsgui/cvstree/parser.yy
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	INTEGER	257
# define	STRING	258
# define	TAG	259
# define	REVNUM	260
# define	ID_CHAR	261
# define	ID_DESCRIPTION	262
# define	ID_TOTREVISIONS	263
# define	ID_SELREVISIONS	264
# define	ID_KEYWORD	265
# define	ID_SYMBOLIC	266
# define	ID_ACCESS	267
# define	ID_LOCKS	268
# define	ID_STRICT	269
# define	ID_BRANCH	270
# define	ID_HEAD	271
# define	ID_WORKING	272
# define	ID_RCS	273
# define	ID_REVISION	274
# define	ID_DATE	275
# define	ID_BRANCHES	276
# define	ID_REVFOLLOW	277
# define	ID_ENDFOLLOW	278
# define	ID_LINES	279
# define	ID_ANYBUTSEP	280
# define	ID_LOCKEDBY	281
# define	ID_AUTHOR	282
# define	ID_STATE	283
# define	ID_COMMITID	284
# define	ID_KOPT	285

#line 1 "parser.yy"

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "common.h"

#if qCvsDebug
#	define YYDEBUG 1
#else
#	define YYDEBUG 0
#endif

#ifdef __MWERKS__
	using namespace std;
#endif

static void expect(kTokens type);

static int sInt;
static CLogStr sStr;
static CRevNumber sRev;

static void printDebug(const char *tag, const char* value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%s%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}

static void printDebug(const char *tag, int value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%d%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}


#line 60 "parser.yy"
#ifndef YYSTYPE
typedef union {
	char *string;
	int aint;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		138
#define	YYFLAG		-32768
#define	YYNTBASE	35

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 102)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,    32,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     3,     6,     8,     9,    13,    15,    16,
      20,    21,    25,    26,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    50,    53,    54,    56,    58,
      59,    63,    64,    67,    68,    70,    72,    76,    77,    79,
      83,    84,    85,    89,    90,    94,    95,    96,    97,    98,
      99,   100,   101,   119,   120,   124,   127,   128,   132,   133,
     134,   140,   141,   145,   146,   150,   151,   154,   155,   158,
     160,   162,   164,   165,   166,   172,   173,   174,   179,   180,
     184,   187,   188,   191,   192,   197,   200,   201,   204,   205,
     209,   211,   212,   216,   217,   222,   223,   226,   227,   232,
     233,   237,   238,   242,   243,   247,   248
};
static const short yyrhs[] =
{
      36,     0,     0,    36,    37,     0,    41,     0,     0,    23,
      38,    49,     0,    24,     0,     0,     1,    39,    43,     0,
       0,    71,    40,    43,     0,     0,    41,    42,     0,   100,
       0,    98,     0,    96,     0,    94,     0,    88,     0,    84,
       0,    80,     0,    78,     0,    73,     0,    45,     0,     0,
      43,    44,     0,     0,     7,     0,     4,     0,     0,     8,
      46,    47,     0,     0,    47,    48,     0,     0,     7,     0,
       4,     0,    53,    50,    51,     0,     0,    55,     0,    50,
      32,    55,     0,     0,     0,    22,    52,    68,     0,     0,
      20,    54,     6,     0,     0,     0,     0,     0,     0,     0,
       0,    21,    56,    72,    33,    57,    72,    33,    58,    72,
      59,    72,    34,    60,    72,    34,    61,    72,     0,     0,
      28,    62,    70,     0,    27,    71,     0,     0,    29,    63,
      70,     0,     0,     0,    25,    64,    72,    65,    72,     0,
       0,    31,    66,    70,     0,     0,    30,    67,    70,     0,
       0,    68,    69,     0,     0,     6,    32,     0,     4,     0,
       5,     0,     3,     0,     0,     0,     9,    74,    72,    75,
      76,     0,     0,     0,    32,    10,    77,    72,     0,     0,
      11,    79,    70,     0,    12,    81,     0,     0,    81,    82,
       0,     0,    71,    34,    83,     6,     0,    13,    85,     0,
       0,    85,    86,     0,     0,    71,    87,    71,     0,    71,
       0,     0,    14,    89,    91,     0,     0,    14,    15,    90,
      91,     0,     0,    91,    92,     0,     0,    71,    34,    93,
       6,     0,     0,    16,    95,     6,     0,     0,    17,    97,
       6,     0,     0,    18,    99,    70,     0,     0,    19,   101,
      70,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   100,   103,   105,   108,   110,   110,   121,   122,   122,
     132,   132,   144,   145,   148,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   161,   163,   166,   168,   175,   184,
     184,   189,   191,   194,   196,   201,   208,   211,   212,   213,
     216,   217,   217,   221,   221,   234,   235,   235,   235,   235,
     235,   235,   235,   280,   280,   289,   297,   297,   306,   306,
     306,   323,   323,   332,   332,   342,   344,   347,   349,   360,
     364,   368,   372,   372,   372,   383,   385,   385,   394,   394,
     404,   408,   410,   413,   413,   433,   437,   439,   442,   442,
     452,   462,   462,   470,   470,   479,   481,   484,   484,   504,
     504,   516,   516,   528,   528,   539,   539
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INTEGER", "STRING", "TAG", "REVNUM", 
  "ID_CHAR", "ID_DESCRIPTION", "ID_TOTREVISIONS", "ID_SELREVISIONS", 
  "ID_KEYWORD", "ID_SYMBOLIC", "ID_ACCESS", "ID_LOCKS", "ID_STRICT", 
  "ID_BRANCH", "ID_HEAD", "ID_WORKING", "ID_RCS", "ID_REVISION", 
  "ID_DATE", "ID_BRANCHES", "ID_REVFOLLOW", "ID_ENDFOLLOW", "ID_LINES", 
  "ID_ANYBUTSEP", "ID_LOCKEDBY", "ID_AUTHOR", "ID_STATE", "ID_COMMITID", 
  "ID_KOPT", "';'", "'/'", "':'", "cvslog", "allDeclarations", 
  "allDeclaration", "@1", "@2", "@3", "rcsDeclarations", "rcsDeclaration", 
  "anyDeclarations", "anyDeclaration", "descDeclaration", "@4", 
  "descListDeclarations", "descListDeclaration", "allrevDeclarations", 
  "revOtherDeclarations", "revBranches", "@5", "revRevision", "@6", 
  "revOtherDeclaration", "@7", "@8", "@9", "@10", "@11", "@12", "@13", 
  "@14", "@15", "@16", "@17", "@18", "revnumListDeclarations", 
  "revnumListDeclaration", "stringDeclaration", "tagDeclaration", 
  "intDeclaration", "totRevDeclaration", "@19", "@20", 
  "selRevDeclaration", "@21", "keyDeclaration", "@22", 
  "symbolicNamesDeclaration", "symbolicListDeclarations", 
  "symbolicListDeclaration", "@23", "accessDeclaration", 
  "accessListDeclarations", "accessListDeclaration", "@24", 
  "locksDeclaration", "@25", "@26", "locksListDeclarations", 
  "locksListDeclaration", "@27", "branchRevDeclaration", "@28", 
  "headRevDeclaration", "@29", "workingFileDeclaration", "@30", 
  "rcsFileDeclaration", "@31", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    35,    36,    36,    37,    38,    37,    37,    39,    37,
      40,    37,    41,    41,    42,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    43,    43,    44,    44,    44,    46,
      45,    47,    47,    48,    48,    48,    49,    50,    50,    50,
      51,    52,    51,    54,    53,    55,    56,    57,    58,    59,
      60,    61,    55,    62,    55,    55,    63,    55,    64,    65,
      55,    66,    55,    67,    55,    68,    68,    69,    69,    70,
      71,    72,    74,    75,    73,    76,    77,    76,    79,    78,
      80,    81,    81,    83,    82,    84,    85,    85,    87,    86,
      86,    89,    88,    90,    88,    91,    91,    93,    92,    95,
      94,    97,    96,    99,    98,   101,   100
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     0,     2,     1,     0,     3,     1,     0,     3,
       0,     3,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     0,     1,     1,     0,
       3,     0,     2,     0,     1,     1,     3,     0,     1,     3,
       0,     0,     3,     0,     3,     0,     0,     0,     0,     0,
       0,     0,    17,     0,     3,     2,     0,     3,     0,     0,
       5,     0,     3,     0,     3,     0,     2,     0,     2,     1,
       1,     1,     0,     0,     5,     0,     0,     4,     0,     3,
       2,     0,     2,     0,     4,     2,     0,     2,     0,     3,
       1,     0,     3,     0,     4,     0,     2,     0,     4,     0,
       3,     0,     3,     0,     3,     0,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       2,     0,     8,    70,     5,     7,     3,     4,    10,    24,
       0,    29,    72,    78,    81,    86,    91,    99,   101,   103,
     105,    13,    23,    22,    21,    20,    19,    18,    17,    16,
      15,    14,    24,     9,    43,     6,    37,    31,     0,     0,
      80,    85,    93,    95,     0,     0,     0,     0,    11,    28,
      27,    25,     0,    46,    58,     0,    53,    56,    63,    61,
      40,    38,    30,    71,    73,    69,    79,     0,    82,    90,
      87,    95,    92,   100,   102,   104,   106,    44,     0,     0,
      55,     0,     0,     0,     0,    41,    45,    36,    35,    34,
      32,    75,    83,     0,    94,     0,    96,     0,    59,    54,
      57,    64,    62,    65,    39,     0,    74,     0,    89,    97,
      47,     0,    42,    76,    84,     0,     0,    60,     0,    66,
       0,    98,     0,    68,    77,    48,     0,    49,     0,     0,
      50,     0,     0,    51,     0,    52,     0,     0,     0
};

static const short yydefgoto[] =
{
     136,     1,     6,    10,     9,    32,     7,    21,    33,    51,
      22,    37,    62,    90,    35,    60,    87,   103,    36,    52,
      61,    78,   116,   126,   128,   131,   134,    81,    82,    79,
     111,    84,    83,   112,   119,    66,    95,    64,    23,    38,
      91,   106,   120,    24,    39,    25,    40,    68,   107,    26,
      41,    70,    93,    27,    43,    71,    72,    96,   115,    28,
      44,    29,    45,    30,    46,    31,    47
};

static const short yypact[] =
{
  -32768,     5,-32768,-32768,-32768,-32768,-32768,    49,-32768,-32768,
     -19,-32768,-32768,-32768,-32768,-32768,   -13,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,    23,-32768,-32768,    48,-32768,     4,    16,
       3,     3,-32768,-32768,    20,    26,    16,    16,    23,-32768,
  -32768,-32768,    29,-32768,-32768,     3,-32768,-32768,-32768,-32768,
      -7,-32768,    27,-32768,-32768,-32768,-32768,   -25,-32768,    28,
  -32768,-32768,     3,-32768,-32768,-32768,-32768,-32768,     4,     4,
  -32768,    16,    16,    16,    16,-32768,    48,-32768,-32768,-32768,
  -32768,     6,-32768,     3,     3,     8,-32768,    10,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    34,-32768,    31,-32768,-32768,
  -32768,     4,    44,-32768,-32768,    46,     4,-32768,    32,-32768,
       4,-32768,    22,-32768,-32768,-32768,     4,-32768,     4,    36,
  -32768,     4,    37,-32768,     4,-32768,    72,    74,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    50,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
      -6,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,   -35,    -1,   -75,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,    12,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		92


static const short yytable[] =
{
       8,    34,    42,    97,    98,    -1,     2,    63,     3,    92,
       3,    75,    76,   -12,   -12,    85,   -12,   -12,   -12,   -12,
      65,   -12,   -12,   -12,   -12,    86,    73,    49,     4,     5,
      50,    88,    74,   -88,    89,    77,   117,   114,   105,    67,
      69,   122,   109,   110,   113,   124,    99,   100,   101,   102,
     118,   127,   121,   129,    80,   125,   132,    11,    12,   135,
      13,    14,    15,    16,   123,    17,    18,    19,    20,    53,
     130,   133,   137,    54,   138,    55,    56,    57,    58,    59,
     104,     0,    48,    94,     0,     0,     0,     0,     0,     0,
       0,     0,   108
};

static const short yycheck[] =
{
       1,    20,    15,    78,    79,     0,     1,     3,     5,    34,
       5,    46,    47,     8,     9,    22,    11,    12,    13,    14,
       4,    16,    17,    18,    19,    32,     6,     4,    23,    24,
       7,     4,     6,     5,     7,     6,   111,     6,    32,    40,
      41,   116,    34,    33,    10,   120,    81,    82,    83,    84,
       6,   126,     6,   128,    55,    33,   131,     8,     9,   134,
      11,    12,    13,    14,    32,    16,    17,    18,    19,    21,
      34,    34,     0,    25,     0,    27,    28,    29,    30,    31,
      86,    -1,    32,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || ((YYLTYPE_IS_TRIVIAL || ! YYLSP_NEEDED) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 319 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
YYPARSE_RETURN_TYPE yyparse (void *);
# else
YYPARSE_RETURN_TYPE yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

YYPARSE_RETURN_TYPE
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 5:
#line 110 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->AllRevs().push_back(CRevFile());
				gRevFile = &gRcsFile->LastRev();
			}

			expect (kRev);
		}
    break;
case 7:
#line 121 "parser.yy"
{ gRcsFile = 0L; expect(kNone); }
    break;
case 8:
#line 122 "parser.yy"
{
										int c = yyvsp[0].aint;
										yyclearin;
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << (char)c;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << (char)c;
									}
    break;
case 10:
#line 132 "parser.yy"
{
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << sStr;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << sStr;

										printDebug("Desp ", sStr.c_str(), true);
    }
    break;
case 27:
#line 168 "parser.yy"
{
							char c = yyvsp[0].aint;
							if(gRevFile != 0L)
								gRevFile->DescLog() << c;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << c;
						}
    break;
case 28:
#line 175 "parser.yy"
{
							if(gRevFile != 0L)
								gRevFile->DescLog() << yyvsp[0].string;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << yyvsp[0].string;
							free(yyvsp[0].string);
						}
    break;
case 29:
#line 185 "parser.yy"
{ expect(kAnyButSep); }
    break;
case 34:
#line 196 "parser.yy"
{
			char c = yyvsp[0].aint;
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << c;
		}
    break;
case 35:
#line 201 "parser.yy"
{
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << yyvsp[0].string;
			free(yyvsp[0].string);
		}
    break;
case 41:
#line 217 "parser.yy"
{ expect(kRevnum); }
    break;
case 43:
#line 222 "parser.yy"
{ expect(kRevnum); }
    break;
case 44:
#line 223 "parser.yy"
{
			if(gRevFile != 0L)
			{
				printDebug("\nRevNum ", sRev.c_str(), true);

				gRevFile->RevNum() = sRev;
			}
			sRev.reset();
		}
    break;
case 46:
#line 235 "parser.yy"
{ expect(kDate); }
    break;
case 47:
#line 236 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_year = sInt - 1900;
			}
		}
    break;
case 48:
#line 242 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mon = sInt;
			}
		}
    break;
case 49:
#line 248 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mday = sInt;
			}
		}
    break;
case 50:
#line 254 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_hour = sInt;
			}
		}
    break;
case 51:
#line 260 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_min = sInt;
			}
		}
    break;
case 52:
#line 266 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_sec = sInt;
			}

			expect(kNone);
			
			if(gRevFile != 0L)
			{
				printDebug("Date ", asctime(&(gRevFile->RevTime())), false);
			}
		}
    break;
case 53:
#line 280 "parser.yy"
{ expect(kAuthorValue); }
    break;
case 54:
#line 281 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->Author() = sStr;
				printDebug("Author ", sStr.c_str(), true);
			}
		}
    break;
case 55:
#line 290 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->Locker() = sStr;
				printDebug("Locker ", sStr.c_str(), true);
			}
		}
    break;
case 56:
#line 297 "parser.yy"
{ expect(kStateOrTag); }
    break;
case 57:
#line 298 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->State() = sStr;
                printDebug("State ", sStr.c_str(), true);
			}
		}
    break;
case 58:
#line 306 "parser.yy"
{ expect(kInt); }
    break;
case 59:
#line 307 "parser.yy"
{
			expect(kInt);
			if(gRevFile != 0L)
			{
				gRevFile->ChgPos() = sInt;
				printDebug("Lines +", sInt, false);
			}
		}
    break;
case 60:
#line 315 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->ChgNeg() = sInt;
				printDebug(" ", sInt, true);
			}
		}
    break;
case 61:
#line 323 "parser.yy"
{ expect(kKeyword); }
    break;
case 62:
#line 324 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->KeywordSubst() = sStr;
				printDebug("KeywordSubst ", sStr.c_str(), true);
			}			
		}
    break;
case 63:
#line 332 "parser.yy"
{ expect(kID); }
    break;
case 64:
#line 333 "parser.yy"
{
		if(gRevFile != 0L)
			{
				gRevFile->CommitID() = sStr;
				printDebug("CommitID ", sStr.c_str(), true);
			}
		}
    break;
case 68:
#line 349 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->BranchesList().push_back(sRev);
			}

			sRev.reset();
			expect(kRevnum);
		}
    break;
case 69:
#line 361 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); }
    break;
case 70:
#line 365 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); }
    break;
case 71:
#line 369 "parser.yy"
{ sInt = yyvsp[0].aint; }
    break;
case 72:
#line 373 "parser.yy"
{ expect(kInt); }
    break;
case 73:
#line 374 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->TotRevisions() = sInt;
			}
		}
    break;
case 76:
#line 385 "parser.yy"
{ expect(kInt); }
    break;
case 77:
#line 386 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->SelRevisions() = sInt;
			}
		}
    break;
case 78:
#line 395 "parser.yy"
{ expect(kKeyword); }
    break;
case 79:
#line 396 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->KeywordSubst() = sStr;
			}
		}
    break;
case 83:
#line 414 "parser.yy"
{
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->SymbolicList().push_back(newRev);
			}
		}
    break;
case 84:
#line 423 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastSymbName().Tag();
				gRcsFile->LastSymbName() = sRev;
			}
			sRev.reset();
		}
    break;
case 88:
#line 443 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		}
    break;
case 90:
#line 452 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		}
    break;
case 91:
#line 463 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = false;
			}
		}
    break;
case 93:
#line 470 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = true;
			}
		}
    break;
case 97:
#line 485 "parser.yy"
{
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->LocksList().push_back(newRev);
			}
		}
    break;
case 98:
#line 494 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastLock().Tag();
				gRcsFile->LastLock() = sRev;
			}
			sRev.reset();
		}
    break;
case 99:
#line 505 "parser.yy"
{ expect(kRevnumOrNil); }
    break;
case 100:
#line 506 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->BranchRev() = sRev;
				printDebug("Branch :", sRev.c_str(), true);
			}
			sRev.reset();
		}
    break;
case 101:
#line 517 "parser.yy"
{ expect(kRevnum); }
    break;
case 102:
#line 518 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->HeadRev() = sRev;
				printDebug("Head :", sRev.c_str(), true);
			}
			sRev.reset();
		}
    break;
case 103:
#line 529 "parser.yy"
{ expect(kString); }
    break;
case 104:
#line 530 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->WorkingFile() = sStr;
				printDebug("WorkingFile :", sStr, true);
			}
		}
    break;
case 105:
#line 540 "parser.yy"
{ expect(kString); }
    break;
case 106:
#line 541 "parser.yy"
{
			// push a new rcs file
			gRcsFiles.push_back(CRcsFile());
			gRcsFile = &gRcsFiles[gRcsFiles.size() - 1];
			gRcsFile->RcsFile() = sStr;
		}
    break;
}

#line 709 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 548 "parser.yy"


void yyerror(const char * /*txt*/, ...)
{
	expect(kAnyButSep);
}

static void expect(kTokens type)
{
	expectToken = type;
}

void yylval_set(const char *txt)
{
	yylval.string = strdup(txt);
}

void yylval_set(int anint)
{
	yylval.aint = anint;
}

void yylval_set(const CRevNumber & rev)
{
	sRev = rev;
}

void yyreset(void)
{
	currentLineNumber = 1;
	sStr = "";
	sInt = 0;
	sRev.reset();
	gRcsFiles.erase(gRcsFiles.begin(), gRcsFiles.end());
	gRcsFile = 0L;
	gRevFile = 0L;
	expect(kNone);
}
